<!--
/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/
//-->

//
//	navapi
//	変更履歴
//		2004.02.01	新規作成
//

/** 最後にadl.nav.requestされたパラメータ値 */
var	_g_last_adl_nav_request;

/** 次に遷移するURL */
var	_g_nextURL;

var navapi;
var navURL;

function initURL(s){
	navURL = s;
}

function navGetValue(cp,s){
	var retStr = "Method=GetValue&";
	retStr += "DataModel=" + cp + "&";
	if(s != null){
		retStr += "&Parameter=" + s;
	}
	return sendParam(retStr);
}

function navSetValue(cp,s1,s2){
	var retStr = "Method=SetValue&";
	retStr += "DataModel=" + cp + "&";
	retStr += "Parameter1=" + s1
	if(s2 != null){
		retStr += "&Parameter2=" + s2 + ";"
	}
	return sendParam(retStr);
}

function sendParam(aryData){
	// get url for ajax from nav url.
	var ajaxURL = navURL;
	var matchURLs = navURL.match(/^[httpsfile]+:\/{2,3}([0-9a-z\.\-:]+?):?[0-9]*?(\/\S+)$/i);
	if (matchURLs && matchURLs[2]) {
		ajaxURL = matchURLs[2];
	}
	
	var xmlhttp = createXMLHttpRequest();
	if (xmlhttp) {
		xmlhttp.open('POST', ajaxURL, false);
		xmlhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded")
		xmlhttp.send(aryData);
	}
	
	alert(ajaxURL + ' => ' + xmlhttp.responseText);
	
	setXMLRes(xmlhttp.responseText);
}


function makeNavAPI(){
	this.initURL = initURL;
	this.navGetValue = navGetValue;
	this.navSetValue = navSetValue;
}

navapi = new makeNavAPI();

function NavDummyLoad(){
	if(_g_nextURL != null){
		parent.frames.main.document.location.href = _g_nextURL;
	}
}

function NavDummyLoad2(s){
	parent.frames.main.document.location.href = s;
}

/**
 * 初期化を行う
 *
 * @param	parameter	""を指定する。
 * @return	正常終了時は"true"を、異常終了時を"false"を返却する。
 */
function NavInitialize(parameter)
{
	if (parameter != "") {
		_setLastError("201");

		return "false";
	}

	_g_last_adl_nav_request = "_none_";
	_g_nextURL = null;

	_setIgnoreSCONavigation(false);

	return "true";
}

/**
 * 終期化を行う。"adl.nav.request"データモデルで遷移先が決定されている場合は、
 * parentに対しナビゲーションコマンドを実行し画面遷移を行う。
 *
 * @param	parameter	""を指定する。
 * @return	正常終了時は"true"を、異常終了時を"false"を返却する。
 */
function NavTerminate(parameter)
{
	if (parameter != "") {
		_setLastError("201");

		return "false";
	}

	if (_g_nextURL == null) {
		_setLastError("0");
		return "true";
	}

	if (_getIgnoreSCONavigation()) {
		_setLastError("0");
		return "true";
	}

	parent.main.SCO.location.href = "/sce/scripts/dummy.html"

	_setLastError("0");
	return "true";
}

/**
 * GetValueを行う。データモデルに指定できるデータモデル名は"adl.nav."で始まる
 * データモデル名のみである。"adl.nav.request"が指定された場合は直前の"adl.nav.request"
 * でSetValueされた時のパラメータを返却する。"adl.nav.request_valid"が指定され
 * た場合は、サーバへ問い合わせを行い、可能な場合は"true"を、不可能の場合は"false"
 * を返却する。
 *
 * @param	dataModelName	データモデル名を指定する。
 *							"adl.nav.request"もしくは"adl.nav.request_valid.〜"のみ指定可能である。
 * @return	異常終了時は""を返却する。そうでない場合は、データモデルで要求された値を返却する。
 */
function NavGetValue(dataModelName)
{
	var splitOfDot = dataModelName.split(".");

	if (splitOfDot.length < 3) {
		_setLastError("401");

		return "";
	}

	if (splitOfDot[0] != "adl") {
		_setLastError("401");

		return "";
	}

	if (splitOfDot[1] != "nav") {
		_setLastError("401");

		return "";
	}

	if (splitOfDot[2] == "request") {
		if (splitOfDot.length != 3) {
			_setLastError("401");

			return "";
		}

		_setLastError("0");

		return _g_last_adl_nav_request;
	}
	else if (splitOfDot[2] == "request_valid") {

		if (splitOfDot.length < 4) {
			_setLastError("401");

			return "";
		}

		if ((splitOfDot[3] == "continue") ||
			(splitOfDot[3] == "previous")) {

			if (splitOfDot.length != 4) {
				_setLastError("401");

				return "";
			}

			var	result;
			initXMLRes();
			try {
				result = navapi.navGetValue(dataModelName, null);
			}
			catch (e) {
				_setLastError("301");

				return "";
			}

			var	errorCode = XMLResError;

			if (errorCode != "0") {
				_setLastError(errorCode);

				return "";
			}
			else {
				_setLastError("0");

				return XMLResURL;
			}
		}
		else if (splitOfDot[3] == "choice") {

			if (splitOfDot.length < 5) {
				_setLastError("401");

				return "";
			}

			var	uri = _NavGetChoiceURI(splitOfDot[4], "");

			if (uri == null) {
				_setLastError("301");

				return "";
			}

			var	result;
			initXMLRes()
			try {
				result = navapi.navGetValue(dataModelName, uri);
			}
			catch (e) {
				_setLastError("301");

				return "";
			}

			var	errorCode = XMLResError;

			if (errorCode != "0") {
				_setLastError(errorCode);

				return "";
			}
			else {
				_setLastError("0");

				return XMLResResult;
			}
		}
	}

	_setLastError("401");

	return "";
}

/**
 * parameterで指定された文字列を解析し、"{target=URI}choice"形式かどうかをチェックし、
 * "{target=URI}choice"形式だった場合はURIを取り出し返却を行う。
 *
 * @param	parameter	"{target=URI}choice"形式かどうかをチェックする文字列を指定する。
 *							"adl.nav.request"もしくは"adl.nav.request_valid.〜"のみ指定可能である。
 * @return	"{target=URI}choice"形式だった場合は、取り出したURIを、そうでない場合はnullを返却する。
 */
function _NavGetChoiceURI(parameter, tailString)
{
	tailString = "}" + tailString;

	if (parameter.indexOf("{target=") != 0) {
		return null;
	}

	var	index = parameter.indexOf(tailString);

	if (index == -1) {
		return null;
	}

	if (index + tailString.length != parameter.length) {
		return null;
	}

	return parameter.substring("{target=".length, index);
}
var XMLResError = "";
var XMLResURL = "";
var XMLResResult = "";

function initXMLRes(){
	XMLResError = "";
	XMLResURL = "";
	XMLResResult = "";
}

function setXMLRes(data){
	var buf = data.split("\n");
	for(i in buf){
		if(buf[i].indexOf("ErrorCode=")==0){
			XMLResError = buf[i].replace("ErrorCode=","");
		}else if(buf[i].indexOf("NextURL=")==0){
			XMLResURL = buf[i].replace("NextURL=","");
		}else if(buf[i].indexOf("Result=")==0){
			XMLResResult = buf[i].replace("Result=","");
		}
	}
}

/**
 * SetValueを行う。データモデルに指定できるデータモデル名は"adl.nav.request"のみである。
 * また、parameterに"abandon"もしくは"abandonAll"が指定された場合は異常終了する。
 *
 * @param	dataModelName	データモデル名を指定する。
 *							"adl.nav.request"のみ指定可能である。
 * @param	parameter		設定値を指定する。
 * @return	正常終了時は"true"を、異常終了時を"false"を返却する。
 */
function NavSetValue(dataModelName, parameter)
{
	if (dataModelName.indexOf("adl.nav.request_valid") == 0) {
		_setLastError("404");

		return "false";
	}

	if (dataModelName != "adl.nav.request") {
		_setLastError("401");

		return "false";
	}

	if ((parameter == "continue") ||
		(parameter == "previous") ||
		(parameter == "exit") ||
		(parameter == "exitAll")) {

		var	result;
		initXMLRes();
		try {
			result = navapi.navSetValue(dataModelName, parameter, null);
		}
		catch (e) {
			_setLastError("351");

			return "false";
		}

		var	errorCode = XMLResError;

		if (errorCode != "0") {
			_setLastError(errorCode);

			return "false";
		}
		else {
			_g_last_adl_nav_request = parameter;

			_setLastError("0");

			_g_nextURL = XMLResURL;

			return "true";
		}
	}
	else if ((parameter == "abandon") ||
			(parameter == "abandonAll")) {

		_setLastError("402");

		return "false";
	}
	else if (parameter == "_none_") {
		_g_last_adl_nav_request = parameter;

		_setLastError("0");

		_g_nextURL = null;

		return "true";
	}
	else {
		var	uri = _NavGetChoiceURI(parameter, "choice");

		if (uri == null) {
			_setLastError("406");

			return "false";
		}

		var	result;
		initXMLRes();
		try {
			result = navapi.navSetValue(dataModelName, parameter, uri);
		}
		catch (e) {
			_setLastError("351");

			return "false";
		}

		var	errorCode = XMLResError;

		if (errorCode != "0") {
			_setLastError(errorCode);

			return "false";
		}
		else {
			_g_last_adl_nav_request = parameter;

			_setLastError("0");

			_g_nextURL = XMLResURL;

			return "true";
		}
	}
}

/**
 * コミットを行う。"adl.nav.request"データモデルで遷移先が決定されている場合は、
 * parentに対しナビゲーションコマンドを実行し画面遷移を行う。
 *
 * @param	parameter	""を指定する。
 * @return	正常終了時は"true"を、異常終了時を"false"を返却する。
 */
function NavCommit(parameter)
{
	if (parameter != "") {
		_setLastError("201");
		return "false";
	}

	if (_g_nextURL == null) {
		_setLastError("0");
		return "true";
	}

	if (_getIgnoreSCONavigation()) {
		_setLastError("0");
		return "true";
	}

	parent.main.SCO.location.href = "/sce/scripts/dummy.html"

	_setLastError("0");
	return "true";
}
